PYPANDA: PANDA's Python Interface
========
Overview
--
PYPANDA is a python interface to PANDA. With PYPANDA, you can quickly develop plugins
to analyze behavior of a running system, record a system and analyze replays, or do
nearly anything you can do using PANDA's C/C++ APIs.

Autogenerated python documentation is available at [panda-re.github.io/](https://panda-re.github.io/).

Installation
--
Prior to using pandare **you must install some dependencies**:
```
apt install libvdeplug-dev libpng16-16 libsdl2-2.0-0
```

This pip package is only tested on `x86_64` Ubuntu 18.04.
It is currently only a binray distribution and will certainly only work on `x86_64` hosts as pre-built panda libraries are included.

Then simply install with `pip3 install pandare`. From there, you'll be able to use PANDA with:

```
from pandare import Panda
panda = Panda(generic='i386')
...
```


This is a beta release
---
* Although PANDA is fairly stable, this interface is new and subject to change significantly prior to version 1.0.

* This package is manually generated and may fall behind the code on GitHub.

* Due to size limits on pypi, this package does not include support for PPC guests or big-endian MIPS. If you'd like those, please build from source.
